import ButtonBackHeader from "@/components/buttonBackHeader";
import ButtonSaveHeader from "@/components/buttonSaveHeader";
import { InputForm } from "@/components/inputForm";
import Styles from "@/constants/Styles";
import { apiGetTaskOne, apiReportTask } from "@/lib/api";
import { setUpdateTask } from "@/lib/taskUpdate";
import { useAuthSession } from "@/providers/AuthProvider";
import { router, Stack, useLocalSearchParams } from "expo-router";
import { useEffect, useState } from "react";
import { SafeAreaView, ScrollView, View } from "react-native";
import Toast from "react-native-toast-message";
import { useDispatch, useSelector } from "react-redux";

export default function TaskDivisionReport() {
   const { id, detail } = useLocalSearchParams<{ id: string; detail: string }>();
   const { token, decryptToken } = useAuthSession();
   const [laporan, setLaporan] = useState("");
   const [error, setError] = useState(false);
   const [disable, setDisable] = useState(false);
   const dispatch = useDispatch();
   const update = useSelector((state: any) => state.taskUpdate);
   const [loading, setLoading] = useState(false)

   async function handleLoad() {
      try {
         const hasil = await decryptToken(String(token?.current));
         const response = await apiGetTaskOne({
            user: hasil,
            cat: "data",
            id: detail,
         });
         setLaporan(response.data.report);
      } catch (error) {
         console.error(error);
      }
   }

   useEffect(() => {
      handleLoad();
   }, []);

   function onValidation(val: string) {
      setLaporan(val);
      if (val == "" || val == "null") {
         setError(true);
      } else {
         setError(false);
      }
   }

   function checkAll() {
      if (laporan == "" || laporan == "null" || laporan == undefined || laporan == null || error) {
         setDisable(true);
      } else {
         setDisable(false);
      }
   }

   useEffect(() => {
      checkAll();
   }, [laporan, error]);

   async function handleUpdate() {
      try {
         setLoading(true)
         const hasil = await decryptToken(String(token?.current));
         const response = await apiReportTask(
            {
               report: laporan,
               user: hasil,
            },
            detail
         );
         if (response.success) {
            dispatch(setUpdateTask({ ...update, report: !update.report }));
            Toast.show({ type: 'small', text1: 'Berhasil mengubah data', })
            router.back();
         } else {
            Toast.show({ type: 'small', text1: response.message, })
         }
      } catch (error) {
         console.error(error);
         Toast.show({ type: 'small', text1: 'Terjadi kesalahan', })
      } finally {
         setLoading(false)
      }
   }

   return (
      <SafeAreaView>
         <Stack.Screen
            options={{
               headerLeft: () => (
                  <ButtonBackHeader
                     onPress={() => {
                        router.back();
                     }}
                  />
               ),
               headerTitle: "Laporan Kegiatan",
               headerTitleAlign: "center",
               headerRight: () => (
                  <ButtonSaveHeader
                     category="update"
                     disable={disable || loading}
                     onPress={() => { handleUpdate() }}
                  />
               ),
            }}
         />
         <ScrollView>
            <View style={[Styles.p15, Styles.mb100]}>
               <InputForm
                  label="Laporan Kegiatan"
                  type="default"
                  placeholder="Laporan Kegiatan"
                  required
                  bg="white"
                  value={laporan}
                  onChange={(val) => { onValidation(val) }}
                  error={error}
                  errorText="Laporan kegiatan harus diisi"
                  multiline
               />
            </View>
         </ScrollView>
      </SafeAreaView>
   );
}
